/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package cz.nyms.httpodesilac;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**
 * Třída umožňující načíst nastavení z textového souboru
 * @author jirka
 */
public class Config {

  protected User user;
  
  /**
   * Getter pro získání přihlačovacích informací
   * @return Přihlašovací informace uživatele
   */
  public User getUser() {
    return user;
  }
  
  /**
   * Konstruktor, z domovského adresáře se pokusí získat soubor s údaji o uživateli
   */
  public Config() {
    String filename=System.getProperty("user.home")+System.getProperty("file.separator")+"spoluzaci.conf";
    FileInputStream fis = null;
    BufferedReader br = null;
    String line = null;
    /*to heslo by bylo dobrý ukládat aspoň s caesarovou šifrou, jenze
     * nemám čas se tim zabývat, navic to stejně není moc bezpečný, kdyby to ale
     * používalo KWallet, tak to by bylo lepší
     */
    String username = "", server = "", passwd = "";

    Pattern p = Pattern.compile("([^#]+)=(.+)");
    Matcher m;
    try {
      fis = new FileInputStream(filename);
      br = new BufferedReader(new InputStreamReader(fis));
      while ((line = br.readLine()) != null) {
        m = p.matcher(line);
        if (m.find() && line.charAt(0) != '#') {
          //pythoní dict by na tohle byl elegantnější
          if (m.group(1).equals("username")) {
            username = m.group(2);
          } else if (m.group(1).equals("server")) {
            server = m.group(2);
          } else if (m.group(1).equals("passwd")) {
            passwd = m.group(2);
          }
        }
      }
      fis.close();

    //Test z C++: 14:30, 16:15, 3.6.2008


    } catch (IOException ex) {
      System.err.println("Soubor s konfigurací nejspíš neexistuje");
    }
    user = new User(username, passwd, server);
  }
/**
 * Metoda starající se o uložení konfigurace do souboru v uživatelově adresáři
 */
  public void save() {
    FileWriter fw = null;
    try {
      String home = System.getProperty("user.home");
      String separator = System.getProperty("file.separator");
      String filename = "spoluzaci.conf";
      fw = new FileWriter(home + separator + filename);
      System.out.println(home+separator+filename);
      BufferedWriter bw = new BufferedWriter(fw);
      //heslo z bezpečnostních dlvodů neukládam
      bw.write("username=" + user.name + "\nserver=" + user.domain + "\n");

      bw.close();
    } catch (Exception ex) {
      ex.printStackTrace();
    }
  }

  /**
   * Nastaví uživatelské jméno
   * @param username uživatelské jméno
   */
  public void setName(String username) {
    user.name = username;
  }
  
  /**
   * Nastaví vybranou doménu seznamu
   * @param value Doména seznamu
   */
  public void setServer(String value) {
    user.domain = value;
  }
}
