/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package cz.nyms.httpodesilac;
//nadhera, warning skoro vsude, ale co ma clovek pouzit misto toho,
//aby to bylo soucasti "jazyka", to se nedozvi
import com.sun.image.codec.jpeg.JPEGCodec;
import com.sun.image.codec.jpeg.JPEGEncodeParam;
import com.sun.image.codec.jpeg.JPEGImageEncoder;
import java.awt.Color;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Image;
import java.awt.RenderingHints;
import java.awt.Transparency;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import javax.imageio.ImageIO;
import javax.swing.ImageIcon;

/**
 * Třída sloužící ke zmenšení obrázků
 * @author jirka a UTFG
 */

public class ImgResize {
    private File originalFile, resizedFile;
    private BufferedImage i;
    private int originalWidth;

  public int getOriginalWidth() {
    return originalWidth;
  }
    /**
     * Tak tohle bylo celkem UTFG... pry neni vhodny pouzivat bezny Image.getScaledInstance
     * 
     * @param img zdrojovy obrazek
     * @param targetWidth nova sirka
     * @param targetHeight nova vyska
     * @param hint Zpusob renderovani, tomuhle nerozumim uz vubec..., melo by to byt neco z tohodle:
     * {@code RenderingHints.VALUE_INTERPOLATION_NEAREST_NEIGHBOR},
     *    {@code RenderingHints.VALUE_INTERPOLATION_BILINEAR},
     *    {@code RenderingHints.VALUE_INTERPOLATION_BICUBIC}
     * @param higherQuality Pro lepsi kvalitu obrazku, je to zalozeny na postupnym snizovani velikosti
     * @return obrazek s novym rozlisenim
     */
    private static BufferedImage getScaledInstance(BufferedImage img, int targetWidth,
                       int targetHeight, Object hint, boolean higherQuality)
    {
        int type = (img.getTransparency() == Transparency.OPAQUE) ?
            BufferedImage.TYPE_INT_RGB : BufferedImage.TYPE_INT_ARGB;
        BufferedImage ret = (BufferedImage)img;
        int w, h;
        if (higherQuality) {
            // Use multi-step technique: start with original size, then
            // scale down in multiple passes with drawImage()
            // until the target size is reached
            w = img.getWidth();
            h = img.getHeight();
        } else {
            // Use one-step technique: scale directly from original
            // size to target size with a single drawImage() call
            w = targetWidth;
            h = targetHeight;
        }
        
        do {
            if (higherQuality && w > targetWidth) {
                w /= 2;
                if (w < targetWidth) {
                    w = targetWidth;
                }
            }

            if (higherQuality && h > targetHeight) {
                h /= 2;
                if (h < targetHeight) {
                    h = targetHeight;
                }
            }

            BufferedImage tmp = new BufferedImage(w, h, type);
            Graphics2D g2 = tmp.createGraphics();
            g2.setRenderingHint(RenderingHints.KEY_INTERPOLATION, hint);
            g2.drawImage(ret, 0, 0, w, h, null);
            g2.dispose();

            ret = tmp;
        } while (w != targetWidth || h != targetHeight);

        return ret;
    }
    
    public ImgResize(File originalFile, File resizedFile) throws IOException{
      this.originalFile=originalFile;
      this.resizedFile=resizedFile;
      i=ImageIO.read(originalFile);
      originalWidth=i.getWidth();
    }
    
    /**
     * metoda pro Vytvoření náhledu obrázku
     * @param newWidth
     * @param quality
     * @throws java.io.IOException
     */
    public void resize(int newWidth, double quality) throws IOException{
      //System.out.println(quality);
      if (quality < 0 || quality > 1) {    
            throw new IllegalArgumentException("Kvalita musí být mezi 0 a 1");
        }

        BufferedImage resizedImage = null;
        
        int iWidth = i.getWidth(null);
        int iHeight = i.getHeight(null);
 
        if (iWidth > iHeight) {
            resizedImage = getScaledInstance(i, newWidth, (newWidth * iHeight) / iWidth, RenderingHints.VALUE_INTERPOLATION_NEAREST_NEIGHBOR, true);
            
        } else {
            resizedImage = getScaledInstance(i,(newWidth * iHeight) / iWidth, newWidth,  RenderingHints.VALUE_INTERPOLATION_NEAREST_NEIGHBOR, true);
            
        }
 
        // This code ensures that all the pixels in the image are loaded.
        Image temp = new ImageIcon(resizedImage).getImage();
 
        // Create the buffered image.
        BufferedImage bufferedImage = new BufferedImage(temp.getWidth(null), temp.getHeight(null),
                                                        BufferedImage.TYPE_INT_RGB);
 
        // Copy image to buffered image.
        Graphics g = bufferedImage.createGraphics();
 
        // Clear background and paint the image.
        g.setColor(Color.white);
        g.fillRect(0, 0, temp.getWidth(null), temp.getHeight(null));
        g.drawImage(temp, 0, 0, null);
        g.dispose();
 
        // Write the jpeg to a file.
        FileOutputStream out = new FileOutputStream(resizedFile);
 
        // Encodes image as a JPEG data stream
        JPEGImageEncoder encoder = JPEGCodec.createJPEGEncoder(out);
        JPEGEncodeParam param = encoder.getDefaultJPEGEncodeParam(bufferedImage);
 
        param.setQuality((float)quality, true);
 
        //encoder.setJPEGEncodeParam(param);
        encoder.encode(bufferedImage);
      
    }
}