/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package cz.nyms.httpodesilac.gui;

import cz.nyms.httpodesilac.ImgResize;
import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.io.File;
import java.io.IOException;
import javax.swing.BoxLayout;
import javax.swing.DefaultBoundedRangeModel;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JSlider;
import javax.swing.JTextField;

/**
 *
 * @author jirka
 */
public class DlgResizeImage extends JDialog {

  private File image,  newImage;
  private JSlider sWidth = new JSlider();
  private JTextField tfWidth = new JTextField();
  private ImgResize ir;
  private JSlider sQuality = new JSlider(WIDTH, 0, 100, 85);
  private Container left = new Container();
  private Container leftT = new Container();
  private Container leftB = new Container();
  private Container right = new Container();
  private Container bottom = new Container();
  private Container con = getContentPane();
  private JLabel lblImage = new JLabel();
  public static final int OK = 1;
  //tohle neni vubec hezky, nemusi to fungovat vsude
  private static String tmpdir = System.getProperty("java.io.tmpdir");
  private static String separator = System.getProperty("file.separator");
  private int status = 0;

  public int getStatus() {
    return status;
  }

  public DlgResizeImage() {
    super();
    init();
  }

  public File getNewImage() {
    return newImage;
  }

  public DlgResizeImage(File image) {
    super();
    this.image = image;
    init();
    load();
  }

  private void init() {
    setModal(true);
    setDefaultCloseOperation(JDialog.HIDE_ON_CLOSE);

    this.setLayout(new BorderLayout());


    con.add(left, BorderLayout.WEST);
    con.add(right, BorderLayout.EAST);
    left.setLayout(new BorderLayout());
    left.add(leftT, BorderLayout.NORTH);
    left.add(leftB, BorderLayout.SOUTH);
    setBounds(0, 0, 420, 160);

    leftT.setLayout(new FlowLayout());
    leftB.setLayout(new FlowLayout());
    leftB.add(sWidth);
    tfWidth.setColumns(6);
    leftT.add(new JLabel("Šířka: "));

    leftT.add(tfWidth);

    tfWidth.setEditable(false);
    sWidth.setPaintTicks(true);
    sQuality.setMajorTickSpacing(20);
    sQuality.setPaintTicks(true);
    sQuality.setLabelTable(sWidth.createStandardLabels(50));
    sQuality.setPaintLabels(true);
    right.setLayout(new BoxLayout(right, BoxLayout.Y_AXIS));
    right.add(new JLabel("Kvalita"));
    right.add(sQuality);
    bottom.setLayout(new FlowLayout());
    JButton btnZkusit = new JButton("Zkusit zmenšit");
    bottom.add(lblImage);
    bottom.add(btnZkusit);
    con.add(bottom, BorderLayout.SOUTH);
    btnZkusit.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent arg0) {
        resize();
      }
      });



  }

  private void load() {
    status = 0;
    try {

      newImage = new File(tmpdir + separator + image.getName());
      ir = new ImgResize(image, newImage);
      //sWidth = new JSlider(0, ir.getOriginalWidth(), ir.getOriginalWidth());
      //System.out.println(ir.getOriginalWidth());

      sWidth.setModel(new DefaultBoundedRangeModel(ir.getOriginalWidth(), 0, 0, ir.getOriginalWidth()));
      tfWidth.setText(ir.getOriginalWidth() + "");
      sWidth.setMajorTickSpacing(((int) ir.getOriginalWidth() / 5));
      lblImage.setText(image.getName() + ", " + image.length() + "B");
      sWidth.addChangeListener(new javax.swing.event.ChangeListener() {

        public void stateChanged(javax.swing.event.ChangeEvent evt) {
          change();
        }
      });

    } catch (IOException ex) {
      System.err.println("Nepovedlo se otevřít soubor.");
      System.err.println(ex.getMessage());
    }
  }

  /**
   * Nastaví nový soubor pro zpracování
   * @param newFile nový soubor
   */
  public void changeFile(File newFile) {
    image = newFile;
    load();
  }

  /**
   * Nechá uživatele zmenšovat obrázek tak dlouho, aby byl menší jak 512KB
   */
  private void resize() {
    try {
      ir.resize(sWidth.getValue(), sQuality.getValue() / 100.0);

      if (newImage.length() < 512000) {
        status = OK;
        setVisible(false);
      }
      lblImage.setText(newImage.getName() + ", " + newImage.length() + "B");

    } catch (IOException ex) {
      System.err.println("Nepodařilo se zmenšit obrázek.");
      System.err.println(ex.getMessage());

    }
  }

  /**
   * Zmena hodnoty slideru
   */
  private void change() {
    tfWidth.setText(sWidth.getValue() + "");
  }

  public void showDialog() {
    setVisible(true);

  }
}
