/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package cz.nyms.httpodesilac.gui;

import cz.nyms.httpodesilac.Option;
import cz.nyms.httpodesilac.User;
import cz.nyms.httpodesilac.UserCl;
import cz.nyms.httpodesilac.netcore.HttpCore;
import cz.nyms.httpodesilac.netcore.NetCore;
import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.event.ActionEvent;
import java.io.File;
import java.util.ArrayList;
import java.util.Vector;
import javax.swing.BoxLayout;
import javax.swing.DefaultComboBoxModel;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.filechooser.FileFilter;
import org.apache.commons.httpclient.HttpException;

/**
 *
 * @author jirka
 */
public class Gui extends JFrame {

  boolean connected = false;
  protected NetCore nc = new HttpCore();
  JScrollPane sp = new JScrollPane();
  JTextArea ta = new JTextArea();
  Login l;
  public static String galTmplURL = "http://www.spoluzaci.cz/photoScreen?classroomId=";
  public Container con,  top;
  protected Container imageList = new Container();
  protected JComboBox cbClass = new JComboBox();
  protected Vector<FileForm> galerie = new Vector<FileForm>();
  private int oldId;
  protected JFileChooser fileChoser = new JFileChooser();
  protected FileForm f;
  FileFilter filter = new FileFilter() {

    @Override
    public boolean accept(File f) {
      //na PNG a GIF zatim kaslu


      return f.isDirectory() || f.getName().toLowerCase().endsWith("jpg") ||
              f.getName().toLowerCase().endsWith("jpeg");
    }

    @Override
    public String getDescription() {
      return "Obrázky JPEG";
    }
  };

  /**
   * Přihlášení
   * @param evt
   */
  private void btnLoginActionPerformed(java.awt.event.ActionEvent evt) {
    // TODO add your handling code here:
    char[] chars = l.password.getPassword();

    nc.user = new User(l.username.getText(), new String(chars), ((Option) l.server.getSelectedItem()).getValue());
    if (nc.login()) {
      ta.setText("Přihlášení proběhlo úspěšně.");
      cbClass.setModel(new DefaultComboBoxModel(nc.tridy.toArray()));
      top.setVisible(true);

      Option o = (Option) cbClass.getSelectedItem();
      nc.user = new UserCl(nc.user, o.getValue());
      this.add(imageList, BorderLayout.CENTER);

      con.remove(l);
      initGalleries();

    } else {
      ta.setText("Nepodařilo se přihlásit, možná jsou špatně zadané přihlašovací údaje.");
    }
  }

  /**
   * Změna třídy
   * @param evt
   */
  private void cbClassActionPerformed(java.awt.event.ActionEvent evt) {

    nc.user = new UserCl(nc.user, ((Option) cbClass.getSelectedItem()).getValue());
    UserCl u = (UserCl) nc.user;

    switchClass();
  }

  /**
   * Konstruktor pro Gui
   */
  public Gui() {
    super("httpOdesílač");
    fileChoser.setFileFilter(filter);
    setLayout(new BorderLayout());
    con = getContentPane();
    setBounds(0, 0, 600, 400);//celkem rozumny rozmery
    l = new Login(new DefaultComboBoxModel(getServers().toArray()));
    l.btnLogin.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(java.awt.event.ActionEvent evt) {
        btnLoginActionPerformed(evt);
      }
    });

    top = new Container();

    con.add(l, BorderLayout.CENTER);
    con.add(top, BorderLayout.NORTH);

    sp.setViewportView(ta);
    con.add(sp, BorderLayout.SOUTH);
    setVisible(true);
    setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    top.setLayout(new BoxLayout(top, BoxLayout.X_AXIS));

    JButton but = new JButton("Načíst soubory");
    top.add(but);
    fileChoser.setMultiSelectionEnabled(true);
    but.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent arg0) {
        int returnVal = fileChoser.showOpenDialog(null);
        if (returnVal == JFileChooser.APPROVE_OPTION) {
          File[] files = fileChoser.getSelectedFiles();
          f.loadImages(files);
        }
      }
    });
    top.add(new JLabel("                   Vyber si třídu  "));
    top.add(cbClass);
    top.setVisible(false);

    cbClass.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        cbClassActionPerformed(evt);
      }
      });
  }

  /**
   * Metoda pro získání seznamu serverů seznamu
   * @return seznam serveru, se kteryma se lze prihlasit ke sluzbam seznamu
   */
  protected ArrayList<Option> getServers() {
    ArrayList<Option> optList = null;
    try {
      String url = "http://login.szn.cz/?serviceId=spoluzaci&loggedURL=http%3A%2F%2Fwww.spoluzaci.cz%2FsessionProcess%3Furi%3D%252F";
      optList = nc.getOptionsFromPage(url);

    } catch (HttpException ex) {
      System.err.println(ex.getMessage());
      ta.setText("Chyba při komunikaci se serverem. Nelze získat seznam serverů.");

      return null;
    } finally {
      nc.close();
      return optList;

    }
  }

  /**
   * Inicializace formulářů pro uložení fotek, co třída, to formulář
   */
  private void initGalleries() {
    //pro kazdou tridu vlastni formular
    //Vector<FileForm> forms = new Vector<FileForm>();

    for (Option o : nc.tridy) {
      f = new FileForm(nc, new UserCl(nc.user, o.getValue()));
      f.setVisible(false);
      galerie.add(f);
    }

    oldId = cbClass.getSelectedIndex();

    f = galerie.get(oldId);
    f.setVisible(true);
    add(f, BorderLayout.CENTER);

  }

  /**
   * Metoda pro zmenu formulare tridy
   */
  private void switchClass() {
    f.invalidate();
    remove(galerie.get(oldId));
    oldId = cbClass.getSelectedIndex();
    f = galerie.get(oldId);
    if (!f.init) {
      setSize(getWidth() - 1, getHeight());
      setSize(getWidth() + 1, getHeight());
      f.init = true;
    }


    doLayout();
    repaint();
    f.setVisible(true);
    add(f, BorderLayout.CENTER);
    f.repaint();
  }
  
  public static void main(String[] args){
    
    Gui g=new Gui();
  }
}
