/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package cz.nyms.httpodesilac.netcore;

import cz.nyms.httpodesilac.Input;
import cz.nyms.httpodesilac.Option;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import cz.nyms.httpodesilac.User;
import cz.nyms.httpodesilac.UserCl;
import cz.nyms.httpodesilac.gui.ImageItem;
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.LinkedList;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import org.apache.commons.httpclient.Cookie;
import org.apache.commons.httpclient.HttpClient;
import org.apache.commons.httpclient.HttpException;
import org.apache.commons.httpclient.HttpMethod;
import org.apache.commons.httpclient.NameValuePair;
import org.apache.commons.httpclient.cookie.CookiePolicy;
import org.apache.commons.httpclient.methods.GetMethod;
import org.apache.commons.httpclient.methods.PostMethod;
import org.apache.commons.httpclient.methods.multipart.FilePart;
import org.apache.commons.httpclient.methods.multipart.MultipartRequestEntity;
import org.apache.commons.httpclient.methods.multipart.Part;
import org.apache.commons.httpclient.methods.multipart.StringPart;

/**
 * Třída implementující většinu metod pro práci se serverem spoluzaci.cz
 * @author jirka
 */
abstract public class NetCore {

  protected Pattern p;
  protected Matcher m;
  protected HttpClient client;
  protected HttpMethod get=null;
  protected PostMethod post=null;
  public LinkedList<Option> tridy;
  public User user;
  LinkedList<Option> galerie;
  protected Input hash,  entityType,  newFolder,  fileId;
  public String forms,  formFolderList,  formCreateFolder;
  static String galTmplURL = "http://www.spoluzaci.cz/photoScreen?classroomId=";

  
  /**
   * Metoda sloužící pro nastavení defaultních hodnot
   */
  private void setDefaults(){
    client = new HttpClient();
    client.getParams().setParameter("http.protocol.content-charset", "UTF-8");
    client.getHttpConnectionManager().getParams().setConnectionTimeout(5000);
    client.getParams().setCookiePolicy(CookiePolicy.BROWSER_COMPATIBILITY);    
  }
  public NetCore(User user) {
    this.user = user;
    setDefaults();
  }

  public NetCore() {
    setDefaults();
  }

  /**
   * metoda zajiťující přihlášení, lze ji vytvořit jak pro HTTP tak i pro HTTPS
   * @return True, pokud se povedlo přihlásit, jinak false
   */
  abstract public boolean login();

  /**
   * Metoda vracející InputStream, po jejím zavolání je nutné zavolat i metodu pro ukončení spojení!!!
   * @param targetURL adresa, ze které má metoda číst
   * @return vraci vystup z http stranky
   * @throws org.apache.commons.httpclient.HttpException
   */
  public InputStream pageStream(String targetURL) throws HttpException {
    try {

      get = new GetMethod(targetURL);
      int status = client.executeMethod(get);
      System.out.println(status + " - " + get.getPath());
      get.getParams().setUriCharset("utf-8");
      InputStream ret = get.getResponseBodyAsStream();
      return ret;
    } catch (Exception ex) {
      throw new HttpException(ex.getMessage());
    }
  }

  
  /**
   * @param form kód html, který obsahuje inputy
   * @return arrayylist inputů
   */
  public ArrayList<Input> getInputListFromForm(String form) {
    ArrayList<Input> l = new ArrayList<Input>();
    
    //conscriptuv magicky regexp: <input ((name="[^"]*")|(value="[^"]*")|(type="[^"]*")|[^/])*/> 
    //jen je potreba u nej urcit parametry, pze muzou mit ruzny poradi
    //pak staci pouzit jen (.+)=\"(.+)\" a 
    String line = form;
    
    p = Pattern.compile("<input ((name=\"[^\"]*\")|(value=\"[^\"]*\")|(type=\"[^\"]*\")|[^/])*/> ");
    Pattern p2 = Pattern.compile("(.+)=\"(.+)\"");
    Matcher m2 = null;
    String[] pair;
    String name, value, type;
    
    m = p.matcher(line);
    while (m.find()) {
      name = "";
      value = "";
      type = "";
      String[] matches = {m.group(2), m.group(3), m.group(4)};
      for (String s : matches) {
        if (s != null) {
          m2 = p2.matcher(s);
        }
        if (m2.find()) {
          pair = new String[]{m2.group(1), m2.group(2)};
          //vyprdnout se na to... switch je celkem naprd...
          if (pair[0].equals("value")) {
            value = pair[1];
          } else if (pair[0].equals("name")) {
            name = pair[1];
          } else if (pair[0].equals("type")) {
            type = pair[1];
          }
        }
      }
      if (!type.equals("submit") || !type.equals("file")) {
        l.add(new Input(name, value, type));
      }

    }
    return l;
  }

  /**
   * Metoda, ktera ziská seznam optionů ze selectu
   * @param targetURL adresa formulare
   * @return seznam polozek ve formulari
   * @throws org.apache.commons.httpclient.HttpException
   */
  public ArrayList<Option> getOptionsFromPage(String targetURL) throws HttpException {
    ArrayList<Option> options = new ArrayList<Option>();
    try {

      String line;
      BufferedReader in = new BufferedReader(new InputStreamReader(pageStream(targetURL),"utf8"));
      //jeste ze tam seznam ma tu mezeru, bez ni by se to vybiralo hur
      p = Pattern.compile("<option value=\"(.+)\" (.*)>(.+)</option>");

      while ((line = in.readLine()) != null) {
        m = p.matcher(line);
        while (m.find()) {
          options.add(new Option(m.group(3), m.group(1)));
        }
      }
    } catch (IOException ex) {
      System.err.println("Nepodařilo se připojit k " + ex.getMessage() + ", použiji výchozí hodnoty");

      options.add(new Option("@spoluzaci.cz", "spoluzaci.cz"));
      options.add(new Option("@seznam.cz", "seznam.cz"));
      options.add(new Option("@stream.cz", "stream.cz"));
    } finally {
      get.releaseConnection();
    }
    return options;
  }

  /**
   * Metoda pro uzavření otevřených spojení
   */
  public void close() {
    if (post != null && get.hasBeenUsed()) {
      get.releaseConnection();
      System.out.println("----");
    }
    if (post != null && post.hasBeenUsed()) {
      get.releaseConnection();
      System.out.println("____");
    }
  }

  
  /**
   * Vypíše obdržené cookies, pro testovací účely
   */
  public void printCookies() {
    Cookie[] cookies = client.getState().getCookies();

    for (Cookie c : cookies) {
      System.out.println(c.getName() + " - " + c.getValue());
    }

  }

  /**
   * Z url načte html kód obsahující obsah formulářů pro vytvoření složky a uložení obrázku
   * @param url adresa stránky s formulářem
   */
  protected void getForms(String url) {
    BufferedReader in = null;
    try {
      UserCl user = (UserCl) this.user;
      String line;

//
      p = Pattern.compile("<form .+data\">(.+)</form>");

      in = new BufferedReader(new InputStreamReader(pageStream(url),"utf8"));

      while ((line = in.readLine()) != null) {
        m = p.matcher(line);
        if (m.find()) {
          forms = m.group();

          this.getFolderListForm();
          this.getCreateFolderForm();
          break;
        }

      }
      in.close();
      //close();
    } catch (IOException ex) {
      System.out.println("chyba při komunikaci se serverem");
    }
  }

  /**
   * ze stringu forms vytáhne formulář s dostupnýma složkama
   */
  protected void getFolderListForm() {
    p = Pattern.compile("<form .+data\">(.+)</form> .+ <form");
    m = p.matcher(forms);
    if (m.find()) {
      formFolderList = m.group(1);
    }
  }

  /**
   * ze stringu forms vytáhne formulář zajiťující vytvoření složky
   */
  protected void getCreateFolderForm() {
    p = Pattern.compile("<form.+id=\"folder\">(.+)</form>");
    m = p.matcher(forms);
    if (m.find()) {
      formCreateFolder = m.group(1);
    }
  }

  /**
   * Metoda pro ziskani vektoru s vytvořenýma galeriema
   * @param url
   * @return Seznam dostupnych galerií
   */
  public LinkedList<Option> getGalleryList(String url) {
    LinkedList<Option> options = new LinkedList<Option>();
    getForms(url);
    p = Pattern.compile("<option value=\"([0-9]+)\">([^<]+)</option>");
    m = p.matcher(formFolderList);
    while (m.find()) {
      options.add(new Option(m.group(2), m.group(1)));
    }
    return options;
  }

  /**
   * Metoda pro vytvoření nové složky
   * @param name jméno složky
   */
  public void createFolder(String name) {
    UserCl u = (UserCl) user;
    getForms(galTmplURL + u.getClassId());
    getCreateFolderForm();
    ArrayList<Input> inputs = getInputListFromForm(formCreateFolder);
    String url = "http://www.spoluzaci.cz/repositoryFolderProcess";

    NameValuePair[] pairs = new NameValuePair[inputs.size()];

    try {
      post = new PostMethod(url);
      int n = 0;
      for (Input i : inputs) {
        if (!i.getName().equals("newFolder")) {
          pairs[n] = new NameValuePair(i.getName(), i.getValue());
          n++;
        }

      }
      pairs[n] = new NameValuePair("newFolder", name);
      post.setRequestBody(pairs);
      client.executeMethod(post);
      BufferedReader br = new BufferedReader(new InputStreamReader(post.getResponseBodyAsStream(), "utf8"));
      String line;
      while ((line = br.readLine()) != null) {
        System.out.println(line);
      }
      close();
    } catch (IOException ex) {
      System.out.println("chyba");
      System.err.println(ex.getMessage());
    } finally {
      post.releaseConnection();
    }


  }
  /**
   * Metoda zajišťující odeslání souboru
   * @param item Položka s se souborem, popisem atd...
   * @param folder "Číslo" složky na seznamu
   */
  synchronized public void sendFile(ImageItem item, String folder) {
    try {

      ArrayList<Input> inputs = getInputListFromForm(formFolderList);
      String url = "http://www.spoluzaci.cz/photoProcess";
      Part[] parts = new Part[inputs.size()];
      UserCl u = (UserCl) user;
      try {
        getForms(galTmplURL + u.getClassId());
        getFolderListForm();

        int n = 0;
        for (Input i : inputs) {

          if (i.getType().equals("hidden")) {
            parts[n] = new StringPart(i.getName(), i.getValue());
            n++;
          }
        }
        parts[n++] = new StringPart("description", item.getPopis(), "UTF-8");
        parts[n++] = new StringPart("folderId", folder);
        parts[n++] = new FilePart("newFile", item.getFile());
        //System.out.println("abc");
      } catch (FileNotFoundException ex) {
        System.err.println("Soubor nelze najít");
      }
      post = new PostMethod(url);
      post.setRequestEntity(new MultipartRequestEntity(parts, post.getParams()));

      client.executeMethod(post);

      BufferedReader br = new BufferedReader(
              new InputStreamReader(post.getResponseBodyAsStream(), "utf8"));
      String line;
      while ((line = br.readLine()) != null) {
        System.out.println(line);
      }
      //close();

    } catch (IOException ex) {
      System.err.println(ex.getMessage());
    } catch (Exception ex) {
      System.err.println(ex.getMessage());
    }

  }
}

